<template>
  <Filter @update="search"></Filter>
  <!-- 财务报表 -->
  <mtp-table-scroll>
    <template #default="{ scroll }">
      <a-table :columns="columns" class="srcollYTable" :pagination="false" :expandedRowKeys="expandedRowKeys" :customRow="Rowclick" :rowKey="(record,index)=>index" :data-source="tableList" :scroll="scroll"> </a-table>
    </template>
  </mtp-table-scroll>
  <!-- 明细 -->
  <mtp-table-detail :columns="columnsDetail" :data-source="detailTableList" :tabs="tabList" v-model:visible="visible" @change="changeTab" />
</template>

<script lang="ts">
import MtpTableScroll from '@/common/components/tableScroll/index.vue';
import Filter from '../../components/filterTable/index.vue';
import { defineComponent, queryTableList } from '@/common/export/table';
import { TypeAndTime } from '@/views/report/interface';
import { handleInitTypeAndTime } from '@/views/report/setup';
import { Ermcp3FinanceReport, FinanceReportReq } from '@/services/go/ermcp/report/interface';
import { qryFinanceReport } from '@/services/go/ermcp/report';
import { ComposeTableDetailParam, handleComposeTable_detail } from '@/common/setup/table/compose';
import { queryResultLoadingAndInfo } from '@/common/methods/request/resultInfo';
import { ref, watch } from 'vue';
import { EnumRouterName } from '@/common/constants/enumRouterName';
import { getTableButton } from '@/common/setup/table/button';
import MtpTableDetail from '@/common/components/tableDetail/index.vue';

export default defineComponent({
  name: 'finance-report',
  components: {
    MtpTableScroll,
    Filter,
    MtpTableDetail,
  },
  setup() {
    let cycletime = '';
    // 表格列表数据
    const { loading, tableList, queryTable } = queryTableList<Ermcp3FinanceReport>();
    // 控制明细显示/隐藏
    const visible = ref(true);
    // 获取列表数据
    const queryTableAction = () => {
      const { getInitTime, getInitType } = handleInitTypeAndTime();
      cycletime = getInitTime();
      const param: FinanceReportReq = {
        cycletype: getInitType(),
        cycletime,
        querytype: 1,
      };
      // 获取列表数据
      queryTable(qryFinanceReport, param).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        } else {
          changeTab(tabIndex.value)
        }
      });
    };
    const param: ComposeTableDetailParam = {
      queryFn: queryTableAction, // 查询表格数据
      tableName: 'table_pcweb_finance_report', // 表头key
      menuType: EnumRouterName.finance_report_finance, // 当前tab页对应的code
    };
    const {
      columns,
      updateColumn, //  表头数据
      columnsDetail,
      registerColumnDetail,
      detailTableList, // 明细表头数据
      expandedRowKeys,
      selectedRow,
      Rowclick, // 表格事件
    } = handleComposeTable_detail<Ermcp3FinanceReport>(param);
    const chaceSearchValue = ref<TypeAndTime>();

    // 底部明细标签
    const tabList = getTableButton();
    // 当前选中的标签
    const tabIndex = ref(0);

    // 切换明细
    function changeTab(index: number) {
      const { code, lable } = tabList[index];
      tabIndex.value = index;
      detailTableList.value = [];
      visible.value = true;

      const param: FinanceReportReq = {
        querytype: 2,
        cycletype: 0,
        cycletime,
        currencyid: 0,
        sumfields: '2',
        userid: chaceSearchValue.value?.userid,
      };

      if (code === 'finance_report_finance_category_breakdown') {
        // 商品明细
        // 注册表头
        registerColumnDetail('table_pcweb_financial_statement_category_breakdown');
        param.sumfields = '1,2';
      } else if (code === 'finance_report_finance_brand_details') {
        // 品牌明细
        // 注册表头
        registerColumnDetail('table_pcweb_financial_statement_brand_details');
        param.sumfields = '1,2,3';
      } else {
        console.error(`${lable}没有配置对应的code: ${code},`);
        return;
      }

      if (selectedRow.value) {
        const data = selectedRow.value as Ermcp3FinanceReport;
        const { cycletype, currencyid } = data;
        param.cycletype = cycletype;
        param.currencyid = currencyid;

        // 查询明细数据
        queryResultLoadingAndInfo(qryFinanceReport, loading, param).then((res) => {
          detailTableList.value = res;
        });
      }
    }

    function search(value: TypeAndTime) {
      detailTableList.value = [];
      chaceSearchValue.value = value;
      cycletime = value.cycletime;
      const obj = Object.assign(value, { querytype: 1 });
      queryTable(qryFinanceReport, obj).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        }
      });
    }

    watch(selectedRow, () => changeTab(tabIndex.value))

    return { loading, tableList, visible, columns, updateColumn, search, columnsDetail, detailTableList, expandedRowKeys, selectedRow, Rowclick, tabList, changeTab };
  },
});
</script>